OGRE: Ogre::v1::GLES2DefaultHardwareBufferManager Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | List of all members
Ogre::v1::GLES2DefaultHardwareBufferManager Class Reference

GLES2DefaultHardwareBufferManagerBase as a Singleton. More...

`#include <OgreGLES2DefaultHardwareBufferManager.h>`

Inheritance diagram for Ogre::v1::GLES2DefaultHardwareBufferManager:
[legend]

## Public Types
enum | BufferLicenseType { BLT_MANUAL_RELEASE, BLT_AUTOMATIC_RELEASE }

## Public Member Functions
| GLES2DefaultHardwareBufferManager ()
| ~GLES2DefaultHardwareBufferManager ()
virtual void | _forceReleaseBufferCopies (const HardwareVertexBufferSharedPtr &sourceBuffer)
| Internal method that forces the release of copies of a given buffer. More...
virtual void | _forceReleaseBufferCopies (HardwareVertexBuffer *sourceBuffer)
| Internal method that forces the release of copies of a given buffer. More...
virtual void | _freeUnusedBufferCopies (void)
| Free all unused vertex buffer copies. More...
void | _notifyConterBufferDestroyed (HardwareCounterBuffer *buf)
void | _notifyCounterBufferDestroyed (HardwareCounterBuffer *buf)
| Notification that at hardware counter buffer has been destroyed. More...
void | _notifyIndexBufferDestroyed (HardwareIndexBuffer *buf)
| Notification that a hardware index buffer has been destroyed. More...
void | _notifyUniformBufferDestroyed (HardwareUniformBuffer *buf)
void | _notifyVertexBufferDestroyed (HardwareVertexBuffer *buf)
| Notification that a hardware vertex buffer has been destroyed. More...
virtual void | _releaseBufferCopies (bool forceFreeUnused=false)
| Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE. More...
virtual HardwareVertexBufferSharedPtr | allocateVertexBufferCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, BufferLicenseType licenseType, HardwareBufferLicensee *licensee, bool copyData=false)
| Allocates a copy of a given vertex buffer. More...
HardwareCounterBufferSharedPtr | createCounterBuffer (size_t sizeBytes, HardwareBuffer::Usage usage, bool useShadowBuffer, const String &name="")
| Create counter buffer. More...
HardwareIndexBufferSharedPtr | createIndexBuffer (HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
| Create a hardware index buffer. More...
HardwareUniformBufferSharedPtr | createUniformBuffer (size_t sizeBytes, HardwareBuffer::Usage usage, bool useShadowBuffer, const String &name="")
| Create uniform buffer. More...
HardwareVertexBufferSharedPtr | createVertexBuffer (size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
| Create a hardware vertex buffer. More...
virtual VertexBufferBinding * | createVertexBufferBinding (void)
| Creates a new VertexBufferBinding. More...
virtual VertexDeclaration * | createVertexDeclaration (void)
virtual void | destroyVertexBufferBinding (VertexBufferBinding *binding)
| Destroys a VertexBufferBinding. More...
virtual void | destroyVertexDeclaration (VertexDeclaration *decl)
| Destroys a vertex declaration. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | registerVertexBufferSourceAndCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, const HardwareVertexBufferSharedPtr &copy)
| Registers a vertex buffer as a copy of another. More...
virtual void | releaseVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Manually release a vertex buffer copy for others to subsequently use. More...
virtual void | touchVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Tell engine that the vertex buffer copy intent to reuse. More...

## Static Public Member Functions
static HardwareBufferManager & | getSingleton (void)
| Override standard Singleton retrieval. More...
static HardwareBufferManager * | getSingletonPtr (void)
| Override standard Singleton retrieval. More...

## Detailed Description

GLES2DefaultHardwareBufferManagerBase as a Singleton.

## Member Enumeration Documentation

## ◆ BufferLicenseType

enum Ogre::v1::HardwareBufferManagerBase::BufferLicenseType
| inherited

Enumerator
BLT_MANUAL_RELEASE | Licensee will only release buffer when it says so.
BLT_AUTOMATIC_RELEASE | Licensee can have license revoked.

## Constructor & Destructor Documentation

## ◆ GLES2DefaultHardwareBufferManager()

Ogre::v1::GLES2DefaultHardwareBufferManager::GLES2DefaultHardwareBufferManager | ( |  | ) |
| inline

## ◆ ~GLES2DefaultHardwareBufferManager()

Ogre::v1::GLES2DefaultHardwareBufferManager::~GLES2DefaultHardwareBufferManager | ( |  | ) |
| inline

References OGRE_DELETE.

## Member Function Documentation

## ◆ _forceReleaseBufferCopies() [1/2]

virtual void Ogre::v1::HardwareBufferManager::_forceReleaseBufferCopies | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer | ) |
| inlinevirtualinherited

Internal method that forces the release of copies of a given buffer.

Remarks
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters

  sourceBuffer | The source buffer as a shared pointer. Any buffer copies created from the source buffer are deleted.

Reimplemented from Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::_forceReleaseBufferCopies().

## ◆ _forceReleaseBufferCopies() [2/2]

virtual void Ogre::v1::HardwareBufferManager::_forceReleaseBufferCopies | ( | HardwareVertexBuffer * | sourceBuffer | ) |
| inlinevirtualinherited

Internal method that forces the release of copies of a given buffer.

Remarks
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters

  sourceBuffer | The source buffer as a shared pointer. Any buffer copies created from the source buffer are deleted.

Reimplemented from Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::_forceReleaseBufferCopies().

## ◆ _freeUnusedBufferCopies()

virtual void Ogre::v1::HardwareBufferManager::_freeUnusedBufferCopies | ( | void |  | ) |
| inlinevirtualinherited

Free all unused vertex buffer copies.

Remarks
  This method free all temporary vertex buffers that not in used. In normally, temporary vertex buffers are subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. But in some cases you want to free them to save hardware memory (e.g. application was runs in a long time, you might free temporary buffers periodically to avoid memory overload).

Reimplemented from Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::_freeUnusedBufferCopies().

## ◆ _notifyConterBufferDestroyed()

void Ogre::v1::HardwareBufferManager::_notifyConterBufferDestroyed | ( | HardwareCounterBuffer * | buf | ) |
| inlineinherited

References Ogre::v1::HardwareBufferManagerBase::_notifyCounterBufferDestroyed().

## ◆ _notifyCounterBufferDestroyed()

void Ogre::v1::HardwareBufferManagerBase::_notifyCounterBufferDestroyed | ( | HardwareCounterBuffer * | buf | ) |
| inherited

Notification that at hardware counter buffer has been destroyed.

Referenced by Ogre::v1::HardwareBufferManager::_notifyConterBufferDestroyed().

## ◆ _notifyIndexBufferDestroyed()

void Ogre::v1::HardwareBufferManager::_notifyIndexBufferDestroyed | ( | HardwareIndexBuffer * | buf | ) |
| inlineinherited

Notification that a hardware index buffer has been destroyed.

References Ogre::v1::HardwareBufferManagerBase::_notifyIndexBufferDestroyed().

## ◆ _notifyUniformBufferDestroyed()

void Ogre::v1::HardwareBufferManager::_notifyUniformBufferDestroyed | ( | HardwareUniformBuffer * | buf | ) |
| inlineinherited

References Ogre::v1::HardwareBufferManagerBase::_notifyUniformBufferDestroyed().

## ◆ _notifyVertexBufferDestroyed()

void Ogre::v1::HardwareBufferManager::_notifyVertexBufferDestroyed | ( | HardwareVertexBuffer * | buf | ) |
| inlineinherited

Notification that a hardware vertex buffer has been destroyed.

References Ogre::v1::HardwareBufferManagerBase::_notifyVertexBufferDestroyed().

## ◆ _releaseBufferCopies()

virtual void Ogre::v1::HardwareBufferManager::_releaseBufferCopies | ( | bool | forceFreeUnused = `false` | ) |
| inlinevirtualinherited

Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.

Parameters

  forceFreeUnused | If `true`, free all unused temporary buffers. If `false`, auto detect and free all unused temporary buffers based on temporary buffers utilization.

Reimplemented from Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::_releaseBufferCopies().

## ◆ allocateVertexBufferCopy()

virtual HardwareVertexBufferSharedPtr Ogre::v1::HardwareBufferManager::allocateVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | BufferLicenseType | licenseType,
|  | HardwareBufferLicensee * | licensee,
|  | bool | copyData = `false`
| ) |  |
| inlinevirtualinherited

Allocates a copy of a given vertex buffer.

Remarks
  This method allocates a temporary copy of an existing vertex buffer. This buffer is subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction.

Parameters

  sourceBuffer | The source buffer to use as a copy.
  licenseType | The type of license required on this buffer - automatic release causes this class to release licenses every frame so that they can be reallocated anew.
  licensee | Pointer back to the class requesting the copy, which must implement HardwareBufferLicense in order to be notified when the license expires.
  copyData | If `true`, the current data is copied as well as the structure of the buffer/

Reimplemented from Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::allocateVertexBufferCopy().

## ◆ createCounterBuffer()

HardwareCounterBufferSharedPtr Ogre::v1::HardwareBufferManager::createCounterBuffer | ( | size_t | sizeBytes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer,
|  | const String & | name = `""`
| ) |  |
| inlinevirtualinherited

Create counter buffer.

The update shall be triggered by GpuProgramParameters, if is dirty

Implements Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::createCounterBuffer().

## ◆ createIndexBuffer()

HardwareIndexBufferSharedPtr Ogre::v1::HardwareBufferManager::createIndexBuffer | ( | HardwareIndexBuffer::IndexType | itype,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false`
| ) |  |
| inlinevirtualinherited

Create a hardware index buffer.

Remarks
  Note that because buffers can be shared, they are reference counted so you do not need to worry about destroying them this will be done automatically.

Parameters

  itype | The type in index, either 16- or 32-bit, depending on how many vertices you need to be able to address
  numIndexes | The number of indexes in the buffer
  usage | One or more members of the HardwareBuffer::Usage enumeration.
  useShadowBuffer | If set to `true`, this buffer will be 'shadowed' by one stored in system memory rather than GPU or AGP memory. You should set this flag if you intend to read data back from the index buffer, because reading data from a buffer in the GPU or AGP memory is very expensive, and is in fact impossible if you specify HBU_WRITE_ONLY for the main buffer. If you use this option, all reads and writes will be done to the shadow buffer, and the shadow buffer will be synchronised with the real buffer at an appropriate time.

Implements Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::createIndexBuffer().

## ◆ createUniformBuffer()

HardwareUniformBufferSharedPtr Ogre::v1::GLES2DefaultHardwareBufferManager::createUniformBuffer | ( | size_t | sizeBytes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer,
|  | const String & | name = `""`
| ) |  |
| inlinevirtual

Create uniform buffer.

This type of buffer allows the upload of shader constants once, and sharing between shader stages or even shaders from another materials. The update shall be triggered by GpuProgramParameters, if is dirty

Reimplemented from Ogre::v1::HardwareBufferManager.

References Ogre::Exception::ERR_RENDERINGAPI_ERROR, and OGRE_EXCEPT.

## ◆ createVertexBuffer()

HardwareVertexBufferSharedPtr Ogre::v1::HardwareBufferManager::createVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVerts,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false`
| ) |  |
| inlinevirtualinherited

Create a hardware vertex buffer.

Remarks
  This method creates a new vertex buffer; this will act as a source of geometry data for rendering objects. Note that because the meaning of the contents of the vertex buffer depends on the usage, this method does not specify a vertex format; the user of this buffer can actually insert whatever data they wish, in any format. However, in order to use this with a RenderOperation, the data in this vertex buffer will have to be associated with a semantic element of the rendering pipeline, e.g. a position, or texture coordinates. This is done using the VertexDeclaration class, which itself contains VertexElement structures referring to the source data.
  Note that because vertex buffers can be shared, they are reference counted so you do not need to worry about destroying themm this will be done automatically.

Parameters

  vertexSize | The size in bytes of each vertex in this buffer; you must calculate this based on the kind of data you expect to populate this buffer with.
  numVerts | The number of vertices in this buffer.
  usage | One or more members of the HardwareBuffer::Usage enumeration; you are strongly advised to use HBU_STATIC_WRITE_ONLY wherever possible, if you need to update regularly, consider HBU_DYNAMIC_WRITE_ONLY and useShadowBuffer=true.
  useShadowBuffer | If set to `true`, this buffer will be 'shadowed' by one stored in system memory rather than GPU or AGP memory. You should set this flag if you intend to read data back from the vertex buffer, because reading data from a buffer in the GPU or AGP memory is very expensive, and is in fact impossible if you specify HBU_WRITE_ONLY for the main buffer. If you use this option, all reads and writes will be done to the shadow buffer, and the shadow buffer will be synchronised with the real buffer at an appropriate time.

Implements Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::createVertexBuffer().

## ◆ createVertexBufferBinding()

virtual VertexBufferBinding* Ogre::v1::HardwareBufferManager::createVertexBufferBinding | ( | void |  | ) |
| inlinevirtualinherited

Creates a new VertexBufferBinding.

Reimplemented from Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::createVertexBufferBinding().

## ◆ createVertexDeclaration()

virtual VertexDeclaration* Ogre::v1::HardwareBufferManager::createVertexDeclaration | ( | void |  | ) |
| inlinevirtualinherited

Reimplemented from Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::createVertexDeclaration().

## ◆ destroyVertexBufferBinding()

virtual void Ogre::v1::HardwareBufferManager::destroyVertexBufferBinding | ( | VertexBufferBinding * | binding | ) |
| inlinevirtualinherited

Destroys a VertexBufferBinding.

Reimplemented from Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::destroyVertexBufferBinding().

## ◆ destroyVertexDeclaration()

virtual void Ogre::v1::HardwareBufferManager::destroyVertexDeclaration | ( | VertexDeclaration * | decl | ) |
| inlinevirtualinherited

Destroys a vertex declaration.

Reimplemented from Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::destroyVertexDeclaration().

## ◆ getSingleton()

static HardwareBufferManager& Ogre::v1::HardwareBufferManager::getSingleton | ( | void |  | ) |
| staticinherited

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

## ◆ getSingletonPtr()

static HardwareBufferManager* Ogre::v1::HardwareBufferManager::getSingletonPtr | ( | void |  | ) |
| staticinherited

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ registerVertexBufferSourceAndCopy()

virtual void Ogre::v1::HardwareBufferManager::registerVertexBufferSourceAndCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | const HardwareVertexBufferSharedPtr & | copy
| ) |  |
| inlinevirtualinherited

Registers a vertex buffer as a copy of another.

Remarks
  This is useful for registering an existing buffer as a temporary buffer which can be allocated just like a copy.

Reimplemented from Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::registerVertexBufferSourceAndCopy().

## ◆ releaseVertexBufferCopy()

virtual void Ogre::v1::HardwareBufferManager::releaseVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) |
| inlinevirtualinherited

Manually release a vertex buffer copy for others to subsequently use.

Remarks
  Only required if the original call to allocateVertexBufferCopy included a licenseType of BLT_MANUAL_RELEASE.

Parameters

  bufferCopy | The buffer copy. The caller is expected to delete or at least no longer use this reference, since another user may well begin to modify the contents of the buffer.

Reimplemented from Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::releaseVertexBufferCopy().

## ◆ touchVertexBufferCopy()

virtual void Ogre::v1::HardwareBufferManager::touchVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) |
| inlinevirtualinherited

Tell engine that the vertex buffer copy intent to reuse.

Remarks
  Ogre internal keep an expired delay counter of BLT_AUTOMATIC_RELEASE buffers, when the counter count down to zero, it'll release for other purposes later. But you can use this function to reset the counter to the internal configured value, keep the buffer not get released for some frames.

Parameters

  bufferCopy | The buffer copy. The caller is expected to keep this buffer copy for use.

Reimplemented from Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::touchVertexBufferCopy().

The documentation for this class was generated from the following file:

- OgreGLES2DefaultHardwareBufferManager.h